(defun c:rl()
        (load "cnc")
)

;; AutoLisp program naredi datoteko CNC.TXT,
;; ki vsebujejo podatke o tockah lomljenk
;; pobranih iz baze Acad-a v obliki:
;; n        stevlo tock
;; x1 y1 b1 koord. tocke (x,y), b=tan(fi/4)
;; x2 y2 b2
;; ...
;; 0
;; (C)opyright 1995 Leon Kos

(defun c:cnc( / points ss pline ptype pnum f)
 (defun print-point(ent / p)
   (setq p (assoc 10 (entget ent)))
   (princ (cadr p)  f) (princ " " f)
   (princ (caddr p) f) (princ " " f)
   (princ (cdr (assoc 42 (entget ent))) f) 
   (princ "\n" f)
 )
 (defun mod(x y) (- x (* y(/ x y))))
 
 (setq f (open "CNC.TXT" "w")); dat.tock
 (setq ss (ssget "X" (list '(0 . "POLYLINE"))))
 (setq old-cmdecho (getvar "cmdecho"))
 (setvar "cmdecho" 0)

 (defun scan-polyline (pline do-output / edata)
    (setq ptype (cdr(assoc 70(entget pline))))
    (command "change" pline "" "properties" 
        "color" "green" "")
    (if (= 1 (mod ptype 2))
       (while (eq "VERTEX" (cdr (assoc 0
          (setq edata (entget (setq pline
                     (entnext pline)))))))
         (setq ptype (cdr (assoc 70
              (entget pline))))
         (if (and (< ptype 16) (/= ptype 2))
           (progn 
              (if do-output
                (print-point pline)
              )
              (setq points (1+ points))
           )
         )
       )
       (progn
         (princ "Opozorilo: Rdeca kontura ni zaprta\n")
         (command "change" pline "" 
                "properties" "color" "red" "")
       )
    )
 )
 
 (if (not (null ss)) 
   (progn
      (setq pnum 0 sslen (sslength ss))
      (while (< pnum sslen)
        (setq pline (ssname ss pnum) points 0)
        (setq points (scan-polyline pline nil))
        (if (numberp points)
           (progn 
             (princ points f)
             (princ "\n" f)
             (scan-polyline pline T)
           )
        )
        (setq pnum (1+ pnum))
      )
   )
   (princ "Napaka #1: Ne obstaja nobena zaprta kontura.\n")
 )
 (princ "0\n" f)
 (close f) 
 (setvar "cmdecho" old-cmdecho)
 (princ)
)


